using System;
namespace Terraria
{
	public class Recipe
	{
		public static int maxRequirements = 15;
		public static int maxRecipes = 900;
		public static int numRecipes = 0;
		private static Recipe newRecipe = new Recipe();
		public Item createItem = new Item();
		public Item[] requiredItem = new Item[Recipe.maxRequirements];
		public int[] requiredTile = new int[Recipe.maxRequirements];
		public bool needHoney;
		public bool needWater;
		public bool anyWood;
		public bool anyIronBar;
		public Recipe()
		{
			for (int i = 0; i < Recipe.maxRequirements; i++)
			{
				this.requiredItem[i] = new Item();
				this.requiredTile[i] = -1;
			}
		}
		public void Create()
		{
			int num = 0;
			while (num < Recipe.maxRequirements && this.requiredItem[num].type != 0)
			{
				int num2 = this.requiredItem[num].stack;
				for (int i = 0; i < 58; i++)
				{
					if (Main.player[Main.myPlayer].inventory[i].IsTheSameAs(this.requiredItem[num]) || this.useWood(Main.player[Main.myPlayer].inventory[i].type, this.requiredItem[num].type) || this.useIronBar(Main.player[Main.myPlayer].inventory[i].type, this.requiredItem[num].type))
					{
						if (Main.player[Main.myPlayer].inventory[i].stack > num2)
						{
							Main.player[Main.myPlayer].inventory[i].stack -= num2;
							num2 = 0;
						}
						else
						{
							num2 -= Main.player[Main.myPlayer].inventory[i].stack;
							Main.player[Main.myPlayer].inventory[i] = new Item();
						}
					}
					if (num2 <= 0)
					{
						break;
					}
				}
				num++;
			}
			Recipe.FindRecipes();
		}
		public bool useWood(int invType, int reqType)
		{
			return (reqType == 9 || reqType == 619 || reqType == 620 || reqType == 621 || reqType == 911) && (this.anyWood && (invType == 9 || invType == 619 || invType == 620 || invType == 621 || invType == 911));
		}
		public bool useIronBar(int invType, int reqType)
		{
			return (reqType == 22 || reqType == 704) && (this.anyIronBar && (invType == 22 || invType == 704));
		}
		public static void FindRecipes()
		{
			int num = Main.availableRecipe[Main.focusRecipe];
			float num2 = Main.availableRecipeY[Main.focusRecipe];
			for (int i = 0; i < Recipe.maxRecipes; i++)
			{
				Main.availableRecipe[i] = 0;
			}
			Main.numAvailableRecipes = 0;
			int num3 = 0;
			while (num3 < Recipe.maxRecipes && Main.recipe[num3].createItem.type != 0)
			{
				bool flag = true;
				bool flag2 = false;
				if (Main.guideItem.type > 0 && Main.guideItem.stack > 0 && Main.guideItem.name != "")
				{
					flag2 = true;
				}
				if (flag2)
				{
					for (int j = 0; j < Recipe.maxRequirements; j++)
					{
						if (Main.recipe[num3].requiredItem[j].type == 0)
						{
							break;
						}
						if (Main.guideItem.IsTheSameAs(Main.recipe[num3].requiredItem[j]) || Main.recipe[num3].useWood(Main.guideItem.type, Main.recipe[num3].requiredItem[j].type) || Main.recipe[num3].useIronBar(Main.guideItem.type, Main.recipe[num3].requiredItem[j].type))
						{
							Main.availableRecipe[Main.numAvailableRecipes] = num3;
							Main.numAvailableRecipes++;
							break;
						}
					}
				}
				else
				{
					int num4 = 0;
					while (num4 < Recipe.maxRequirements && Main.recipe[num3].requiredItem[num4].type != 0)
					{
						int num5 = Main.recipe[num3].requiredItem[num4].stack;
						for (int k = 0; k < 58; k++)
						{
							if (Main.player[Main.myPlayer].inventory[k].IsTheSameAs(Main.recipe[num3].requiredItem[num4]) || Main.recipe[num3].useWood(Main.player[Main.myPlayer].inventory[k].type, Main.recipe[num3].requiredItem[num4].type) || Main.recipe[num3].useIronBar(Main.player[Main.myPlayer].inventory[k].type, Main.recipe[num3].requiredItem[num4].type))
							{
								num5 -= Main.player[Main.myPlayer].inventory[k].stack;
							}
							if (num5 <= 0)
							{
								break;
							}
						}
						if (num5 > 0)
						{
							flag = false;
							break;
						}
						num4++;
					}
					if (flag)
					{
						bool flag3 = true;
						int num6 = 0;
						while (num6 < Recipe.maxRequirements && Main.recipe[num3].requiredTile[num6] != -1)
						{
							if (!Main.player[Main.myPlayer].adjTile[Main.recipe[num3].requiredTile[num6]])
							{
								flag3 = false;
								break;
							}
							num6++;
						}
						if (flag3 && (!Main.recipe[num3].needWater || Main.recipe[num3].needWater == Main.player[Main.myPlayer].adjWater) && (!Main.recipe[num3].needHoney || Main.recipe[num3].needHoney == Main.player[Main.myPlayer].adjHoney))
						{
							Main.availableRecipe[Main.numAvailableRecipes] = num3;
							Main.numAvailableRecipes++;
						}
					}
				}
				num3++;
			}
			for (int l = 0; l < Main.numAvailableRecipes; l++)
			{
				if (num == Main.availableRecipe[l])
				{
					Main.focusRecipe = l;
					break;
				}
			}
			if (Main.focusRecipe >= Main.numAvailableRecipes)
			{
				Main.focusRecipe = Main.numAvailableRecipes - 1;
			}
			if (Main.focusRecipe < 0)
			{
				Main.focusRecipe = 0;
			}
			float num7 = Main.availableRecipeY[Main.focusRecipe] - num2;
			for (int m = 0; m < Recipe.maxRecipes; m++)
			{
				Main.availableRecipeY[m] -= num7;
			}
		}
		public static void SetupRecipes()
		{
			Recipe.newRecipe.createItem.SetDefaults(8, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(23, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(523, false);
			Recipe.newRecipe.createItem.stack = 33;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 33;
			Recipe.newRecipe.requiredItem[1].SetDefaults(522, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1333, false);
			Recipe.newRecipe.createItem.stack = 33;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 33;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1332, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(974, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(664, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(427, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(177, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(428, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(178, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(429, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(179, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(432, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(180, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(430, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(181, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(431, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(182, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1245, false);
			Recipe.newRecipe.createItem.stack = 3;
			Recipe.newRecipe.requiredItem[0].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(999, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(985, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Rope");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(966, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Torch");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(235, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(166, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(23, false);
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(286, false);
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults(282, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredItem[1].SetDefaults(23, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mug");
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass");
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Ale");
			Recipe.newRecipe.requiredItem[0].SetDefaults(351, false);
			Recipe.newRecipe.requiredTile[0] = 94;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Bowl of Soup");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bowl");
			Recipe.newRecipe.requiredItem[1].SetDefaults("Mushroom");
			Recipe.newRecipe.requiredItem[2].SetDefaults("Goldfish");
			Recipe.newRecipe.requiredTile[0] = 96;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(968, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(967, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wood");
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Bottle");
			Recipe.newRecipe.createItem.stack = 2;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass");
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Bottled Water");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bottle");
			Recipe.newRecipe.needWater = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1134, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bottle");
			Recipe.newRecipe.needHoney = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(422, false);
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bottled Water");
			Recipe.newRecipe.requiredItem[1].SetDefaults(501, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredItem[2].SetDefaults(369, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(423, false);
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bottled Water");
			Recipe.newRecipe.requiredItem[1].SetDefaults(370, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(59, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(28, false);
			Recipe.newRecipe.createItem.stack = 2;
			Recipe.newRecipe.requiredItem[0].SetDefaults(5, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(23, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredItem[2].SetDefaults(31, false);
			Recipe.newRecipe.requiredItem[2].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Healing Potion");
			Recipe.newRecipe.requiredItem[0].SetDefaults(28, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredItem[1].SetDefaults(183, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Greater Healing Potion");
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(501, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredItem[2].SetDefaults(502, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(110, false);
			Recipe.newRecipe.createItem.stack = 2;
			Recipe.newRecipe.requiredItem[0].SetDefaults(75, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(23, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredItem[2].SetDefaults(31, false);
			Recipe.newRecipe.requiredItem[2].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mana Potion");
			Recipe.newRecipe.requiredItem[0].SetDefaults(110, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredItem[1].SetDefaults(183, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(226, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(28, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(110, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(227, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Healing Potion");
			Recipe.newRecipe.requiredItem[1].SetDefaults("Mana Potion");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(288, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(318, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(317, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults("Obsidian");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(289, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Mushroom");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(290, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(315, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Cactus");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(291, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(317, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Coral");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(292, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Iron Ore");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(292, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Lead Ore");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(293, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(314, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults("Fallen Star");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(294, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(314, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(316, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults("Fallen Star");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(295, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(315, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults("Feather");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(296, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(315, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(314, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults("Gold Ore");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(296, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(315, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(314, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults("Platinum Ore");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(297, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(315, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(314, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(298, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Glowing Mushroom");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(299, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(315, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(300, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(316, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Rotten Chunk");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(300, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(316, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1330, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(301, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(316, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Cactus");
			Recipe.newRecipe.requiredItem[3].SetDefaults("Worm Teeth");
			Recipe.newRecipe.requiredItem[4].SetDefaults("Stinger");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(302, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(317, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(319, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(303, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults("Lens");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(304, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(313, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(315, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults(319, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(305, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(318, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(316, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults(315, false);
			Recipe.newRecipe.requiredItem[4].SetDefaults("Feather");
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1359, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(209, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 243;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1354, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(174, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 243;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1340, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1339, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 243;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1355, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1348, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 243;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1356, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1332, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 243;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1353, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(522, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 243;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1357, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1346, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 243;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1358, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(126, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1345, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 243;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(949, false);
			Recipe.newRecipe.createItem.stack = 10;
			Recipe.newRecipe.requiredItem[0].SetDefaults(593, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(40, false);
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(3, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Flaming Arrow");
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(988, false);
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredItem[1].SetDefaults(974, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(51, false);
			Recipe.newRecipe.createItem.stack = 10;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(75, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Unholy Arrow");
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredItem[1].SetDefaults(69, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Hellfire Arrow");
			Recipe.newRecipe.createItem.stack = 25;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredItem[1].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[2].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(545, false);
			Recipe.newRecipe.createItem.stack = 35;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 35;
			Recipe.newRecipe.requiredItem[1].SetDefaults(522, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1334, false);
			Recipe.newRecipe.createItem.stack = 35;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 35;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1332, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(516, false);
			Recipe.newRecipe.createItem.stack = 45;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 45;
			Recipe.newRecipe.requiredItem[1].SetDefaults(501, false);
			Recipe.newRecipe.requiredItem[1].stack = 6;
			Recipe.newRecipe.requiredItem[2].SetDefaults(526, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1341, false);
			Recipe.newRecipe.createItem.stack = 35;
			Recipe.newRecipe.requiredItem[0].SetDefaults(40, false);
			Recipe.newRecipe.requiredItem[0].stack = 35;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1339, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Meteor Shot");
			Recipe.newRecipe.createItem.stack = 70;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Musket Ball");
			Recipe.newRecipe.requiredItem[0].stack = 70;
			Recipe.newRecipe.requiredItem[1].SetDefaults(117, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(278, false);
			Recipe.newRecipe.createItem.stack = 70;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Musket Ball");
			Recipe.newRecipe.requiredItem[0].stack = 70;
			Recipe.newRecipe.requiredItem[1].SetDefaults(21, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(515, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Musket Ball");
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(546, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Musket Ball");
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(522, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1335, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Musket Ball");
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1332, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1179, false);
			Recipe.newRecipe.createItem.stack = 70;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Musket Ball");
			Recipe.newRecipe.requiredItem[0].stack = 70;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1006, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1302, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1432, false);
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1344, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1349, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1432, false);
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1345, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1350, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1432, false);
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1346, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1351, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1432, false);
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1347, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1352, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1432, false);
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1348, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1342, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1432, false);
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1339, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(67, false);
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults(60, false);
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(287, false);
			Recipe.newRecipe.createItem.stack = 20;
			Recipe.newRecipe.requiredItem[0].SetDefaults(279, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(67, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(94, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(632, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(631, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(913, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(633, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1702, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(170, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1431, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bottle");
			Recipe.newRecipe.requiredItem[1].SetDefaults(75, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Chinese Lantern");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Torch");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tiki Torch");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Torch");
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lamp Post");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Iron Bar");
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Glass");
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredItem[2].SetDefaults("Torch");
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Skull Lantern");
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Torch");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(663, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(662, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Clay Pot");
			Recipe.newRecipe.requiredItem[0].SetDefaults(133, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Pink Vase");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Clay Block");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Bowl");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Clay Block");
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Glass");
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults(169, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(392, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1267, false);
			Recipe.newRecipe.createItem.stack = 20;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass Wall");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Amethyst");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1268, false);
			Recipe.newRecipe.createItem.stack = 20;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass Wall");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Topaz");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1269, false);
			Recipe.newRecipe.createItem.stack = 20;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass Wall");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Sapphire");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1270, false);
			Recipe.newRecipe.createItem.stack = 20;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass Wall");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Emerald");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1271, false);
			Recipe.newRecipe.createItem.stack = 20;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass Wall");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Ruby");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1272, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Glass Wall");
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Amethyst");
			Recipe.newRecipe.requiredItem[2].SetDefaults("Topaz");
			Recipe.newRecipe.requiredItem[3].SetDefaults("Sapphire");
			Recipe.newRecipe.requiredItem[4].SetDefaults("Emerald");
			Recipe.newRecipe.requiredItem[5].SetDefaults("Ruby");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(775, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredItem[1].SetDefaults(23, false);
			Recipe.newRecipe.requiredTile[0] = 217;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1102, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1101, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gray Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gray Brick Wall");
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Gray Brick");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Red Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(133, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Red Brick Wall");
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Red Brick");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Copper Ore");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Brick Wall");
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Copper Brick");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Brick Wall");
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silver Brick");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silver Ore");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Brick Wall");
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Gold Brick");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Gold Ore");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Tin Ore");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Brick Wall");
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Brick");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Brick Wall");
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Brick");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Tungsten Ore");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Brick Wall");
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Brick");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Platinum Ore");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Hellstone Brick");
			Recipe.newRecipe.requiredItem[0].SetDefaults(174, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(3, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(192, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(173, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(330, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(192, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(606, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(577, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(594, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(593, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(595, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(594, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(883, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(664, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(884, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(883, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(587, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(586, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(592, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(591, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(607, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(169, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(608, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(607, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(412, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(408, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(409, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(417, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(412, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(609, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(61, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(610, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(609, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(413, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(172, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(418, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(413, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(414, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(176, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(419, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(414, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(611, false);
			Recipe.newRecipe.createItem.stack = 10;
			Recipe.newRecipe.requiredItem[0].SetDefaults(424, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(133, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(615, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(611, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(612, false);
			Recipe.newRecipe.createItem.stack = 10;
			Recipe.newRecipe.requiredItem[0].SetDefaults(424, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(169, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(616, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(612, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(613, false);
			Recipe.newRecipe.createItem.stack = 10;
			Recipe.newRecipe.requiredItem[0].SetDefaults(424, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredItem[2].SetDefaults(255, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(617, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(613, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(614, false);
			Recipe.newRecipe.createItem.stack = 10;
			Recipe.newRecipe.requiredItem[0].SetDefaults(424, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(618, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(614, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(415, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(364, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(420, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(415, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(416, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(365, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(421, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(416, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(604, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(366, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(605, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(604, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1589, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1104, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1590, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1589, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1591, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1105, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1592, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1591, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1593, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1106, false);
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1594, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1593, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(577, false);
			Recipe.newRecipe.createItem.stack = 5;
			Recipe.newRecipe.requiredItem[0].SetDefaults(56, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(61, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(176, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(2, false);
			Recipe.newRecipe.needWater = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(30, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(2, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(26, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1723, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredTile[0] = 191;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(93, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(623, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(622, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(927, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(624, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(25, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(34, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(48, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(32, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(36, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Piano");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredItem[2].SetDefaults("Book");
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Bed");
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Dresser");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 16;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(651, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(629, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(626, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(639, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(636, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(642, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredItem[2].SetDefaults("Book");
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(645, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(648, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 16;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(650, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(628, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(625, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(638, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(635, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(641, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredItem[2].SetDefaults("Book");
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(644, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(647, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 16;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(912, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(915, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(914, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(917, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(916, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(919, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredItem[2].SetDefaults("Book");
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(920, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(918, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 16;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(652, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(630, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(627, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(640, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(637, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(643, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredItem[2].SetDefaults("Book");
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(646, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(649, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 16;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Sign");
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1447, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1448, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(479, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(480, false);
			Recipe.newRecipe.createItem.stack = 2;
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(498, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Bookcase");
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Book");
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Barrel");
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Grandfather Clock");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Iron Bar");
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Glass");
			Recipe.newRecipe.requiredItem[1].stack = 6;
			Recipe.newRecipe.requiredItem[2].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[2].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Keg");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 14;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Loom");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1706, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1714, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1715, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Bench");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 106;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Sawmill");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Iron Bar");
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredItem[2].SetDefaults("Chain");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyWood = true;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(727, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(728, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(729, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(24, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(196, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(39, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(733, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(734, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(735, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(656, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(657, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(658, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(620, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(730, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(731, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(732, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(653, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(654, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(655, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(619, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(924, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(925, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(926, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(921, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(922, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(923, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(911, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(736, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(737, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(738, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(659, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(660, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(661, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(621, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1703, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(170, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1709, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(170, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1713, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(170, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1719, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(170, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1707, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1127, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1711, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1127, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1717, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1127, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1721, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1127, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1708, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1344, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1712, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1344, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1718, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1344, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1722, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1344, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(894, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(895, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(896, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(881, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(882, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(750, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(816, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(807, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(812, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(276, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(764, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(183, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(818, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(183, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(810, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(183, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(814, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(183, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(763, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(836, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 218;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(770, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(763, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(817, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(763, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(809, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(763, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(813, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(763, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(828, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(763, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(762, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(23, false);
			Recipe.newRecipe.requiredTile[0] = 220;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(769, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults(762, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(815, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(762, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(768, false);
			Recipe.newRecipe.createItem.stack = 4;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(820, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(808, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(811, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(827, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Bone");
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(361, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(362, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.anyWood = true;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].SetDefaults(150, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Red Banner");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Green Banner");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Blue Banner");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Yellow Banner");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(255, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(195, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 13;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(247, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(255, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(248, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(255, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(249, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(255, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(240, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(254, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(241, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(254, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(262, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1282, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(262, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Amethyst");
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1283, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(262, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Topaz");
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1284, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(262, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Sapphire");
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1285, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(262, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Emerald");
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1286, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(262, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Ruby");
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1287, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(262, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Diamond");
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 86;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(259, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(68, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(252, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(259, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(253, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(259, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(978, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(803, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(981, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(979, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(804, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(981, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(980, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(805, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(981, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(250, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(261, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Bottled Water");
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(33, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredItem[2].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[2].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(360, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Stone Block");
			Recipe.newRecipe.requiredItem[0].stack = 100;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(12, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Axe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Hammer");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Broadsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Shortsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Bow");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Amethyst Staff");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Copper Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Amethyst");
			Recipe.newRecipe.requiredItem[1].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Watch");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 14;
			Recipe.newRecipe.requiredTile[1] = 15;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Copper Chandelier");
			Recipe.newRecipe.requiredItem[0].SetDefaults(20, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredItem[2].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Ore");
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Axe");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Hammer");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Broadsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Shortsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Bow");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Topaz Staff");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Topaz");
			Recipe.newRecipe.requiredItem[1].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Watch");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 14;
			Recipe.newRecipe.requiredTile[1] = 15;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tin Chandelier");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tin Bar");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredItem[2].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(11, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(35, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(10, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(7, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(4, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(6, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Iron Bow");
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Iron Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Iron Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Iron Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Ore");
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Anvil");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Axe");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Hammer");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Broadsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Shortsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Bow");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Lead Bar");
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(205, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Iron Door");
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Lead Door");
			Recipe.newRecipe.requiredItem[0].SetDefaults(704, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Trash Can");
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Bathtub");
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 14;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Toilet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cooking Pot");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Iron Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wood");
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Chain");
			Recipe.newRecipe.createItem.stack = 10;
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(14, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Axe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Hammer");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Broadsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Shortsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Bow");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Sapphire Staff");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silver Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Sapphire");
			Recipe.newRecipe.requiredItem[1].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Watch");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 14;
			Recipe.newRecipe.requiredTile[1] = 15;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Silver Chandelier");
			Recipe.newRecipe.requiredItem[0].SetDefaults(21, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredItem[2].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Ore");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Axe");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Hammer");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Broadsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Shortsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Bow");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Emerald Staff");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Emerald");
			Recipe.newRecipe.requiredItem[1].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Watch");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 14;
			Recipe.newRecipe.requiredTile[1] = 15;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Tungsten Chandelier");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Tungsten Bar");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredItem[2].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(13, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Axe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Hammer");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Broadsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Shortsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Bow");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Ruby Staff");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Gold Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Ruby");
			Recipe.newRecipe.requiredItem[1].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 35;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Watch");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 14;
			Recipe.newRecipe.requiredTile[1] = 15;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Crown");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Ruby");
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Gold Chandelier");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredItem[2].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Candle");
			Recipe.newRecipe.requiredItem[0].SetDefaults(19, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Candelabra");
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Gold Bar");
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Torch");
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Ore");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Axe");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 9;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Hammer");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(9, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyWood = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Broadsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Shortsword");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Bow");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Diamond Staff");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Diamond");
			Recipe.newRecipe.requiredItem[1].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 35;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Watch");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 14;
			Recipe.newRecipe.requiredTile[1] = 15;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Crown");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Ruby");
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Chandelier");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredItem[2].SetDefaults(85, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Candle");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[1].SetDefaults(8, false);
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Platinum Candelabra");
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Torch");
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Throne");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Gold Bar");
			Recipe.newRecipe.requiredItem[1].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Throne");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Silk");
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Platinum Bar");
			Recipe.newRecipe.requiredItem[1].stack = 30;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(56, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(44, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(45, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(46, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Shadow Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults(86, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Shadow Scalemail");
			Recipe.newRecipe.requiredItem[0].SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredItem[1].SetDefaults(86, false);
			Recipe.newRecipe.requiredItem[1].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Shadow Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(86, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Nightmare Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(86, false);
			Recipe.newRecipe.requiredItem[1].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("The Breaker");
			Recipe.newRecipe.requiredItem[0].SetDefaults(57, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(86, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(880, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(796, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(799, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(795, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(792, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1329, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(793, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1329, false);
			Recipe.newRecipe.requiredItem[1].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(794, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1329, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(798, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1329, false);
			Recipe.newRecipe.requiredItem[1].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(797, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1329, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(801, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1257, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1329, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Grappling Hook");
			Recipe.newRecipe.requiredItem[0].SetDefaults(85, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(118, false);
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1236, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(181, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1237, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(180, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1238, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(177, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1239, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(179, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1240, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(178, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1241, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(182, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1522, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(181, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1523, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(180, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1524, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(177, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1525, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(179, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1526, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(178, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1527, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(182, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(116, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(198, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(177, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(199, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(178, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(200, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(179, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(201, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(181, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(202, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(182, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(203, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(180, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Blue Phasesaber");
			Recipe.newRecipe.requiredItem[0].SetDefaults(198, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[1].stack = 50;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Red Phasesaber");
			Recipe.newRecipe.requiredItem[0].SetDefaults(199, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[1].stack = 50;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Green Phasesaber");
			Recipe.newRecipe.requiredItem[0].SetDefaults(200, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[1].stack = 50;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Purple Phasesaber");
			Recipe.newRecipe.requiredItem[0].SetDefaults(201, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[1].stack = 50;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("White Phasesaber");
			Recipe.newRecipe.requiredItem[0].SetDefaults(202, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[1].stack = 50;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Yellow Phasesaber");
			Recipe.newRecipe.requiredItem[0].SetDefaults(203, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[1].stack = 50;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(204, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 35;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(127, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredItem[1].SetDefaults(75, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(197, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(98, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[1].stack = 20;
			Recipe.newRecipe.requiredItem[2].SetDefaults(75, false);
			Recipe.newRecipe.requiredItem[2].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Meteor Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Meteor Suit");
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Meteor Leggings");
			Recipe.newRecipe.requiredItem[0].SetDefaults(117, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(151, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(154, false);
			Recipe.newRecipe.requiredItem[0].stack = 40;
			Recipe.newRecipe.requiredItem[1].SetDefaults(150, false);
			Recipe.newRecipe.requiredItem[1].stack = 40;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(152, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(154, false);
			Recipe.newRecipe.requiredItem[0].stack = 60;
			Recipe.newRecipe.requiredItem[1].SetDefaults(150, false);
			Recipe.newRecipe.requiredItem[1].stack = 50;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(153, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(154, false);
			Recipe.newRecipe.requiredItem[0].stack = 50;
			Recipe.newRecipe.requiredItem[1].SetDefaults(150, false);
			Recipe.newRecipe.requiredItem[1].stack = 45;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(190, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(331, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(209, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1310, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults(209, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(191, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(331, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredItem[1].SetDefaults(209, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(185, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(331, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(210, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(228, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(331, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(229, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(331, false);
			Recipe.newRecipe.requiredItem[0].stack = 16;
			Recipe.newRecipe.requiredItem[1].SetDefaults(209, false);
			Recipe.newRecipe.requiredItem[1].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(230, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(331, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredItem[1].SetDefaults(210, false);
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(174, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(173, false);
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 77;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(119, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(55, false);
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(120, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(121, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(122, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(217, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(219, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Handgun");
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(231, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(232, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(233, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(175, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(273, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(46, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(155, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(190, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults(121, false);
			Recipe.newRecipe.requiredTile[0] = 26;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(273, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(795, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(155, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(190, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults(121, false);
			Recipe.newRecipe.requiredTile[0] = 26;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(675, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(273, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1570, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(674, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(368, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1570, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(757, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(675, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(674, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1570, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(389, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(527, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(528, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[2].stack = 7;
			Recipe.newRecipe.requiredItem[3].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[3].stack = 7;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(364, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Mask");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Hat");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Breastplate");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Leggings");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Drill");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(776, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Chainsaw");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(991, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Repeater");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Cobalt Sword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(537, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(381, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1104, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Mask");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Headgear");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Breastplate");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Leggings");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Drill");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1188, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Chainsaw");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1222, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Repeater");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Palladium Sword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1186, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1184, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(365, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Hat");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Hood");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Chainmail");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Greaves");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Drill");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Pickaxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Chainsaw");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Waraxe");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Repeater");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Sword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mythril Halberd");
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(525, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(382, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1105, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Mask");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Headgear");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Breastplate");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Leggings");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Drill");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1195, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Chainsaw");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1223, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Repeater");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Sword");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Orichalcum Halberd");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1220, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1191, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(366, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 133;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Adamantite Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(402, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(400, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Adamantite Breastplate");
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 24;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Adamantite Leggings");
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Adamantite Drill");
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(778, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Adamantite Chainsaw");
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(993, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Adamantite Repeater");
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(482, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Adamantite Glaive");
			Recipe.newRecipe.requiredItem[0].SetDefaults(391, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(524, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(366, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredItem[1].SetDefaults(221, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1106, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 133;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Titanium Mask");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1216, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1217, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Titanium Breastplate");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 24;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Titanium Leggings");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Titanium Drill");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1202, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Titanium Chainsaw");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1224, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Titanium Repeater");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1199, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Titanium Trident");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1198, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1221, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1106, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredItem[1].SetDefaults(221, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(559, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(553, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(558, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(551, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 24;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(552, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(579, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(990, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(578, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(368, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(550, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(947, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 133;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Chlorophyte Helmet");
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1001, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1003, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1004, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 24;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1005, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1231, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1230, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1232, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1233, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1262, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1234, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1229, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1227, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1226, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1228, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1235, false);
			Recipe.newRecipe.createItem.stack = 50;
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1503, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1508, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1504, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1508, false);
			Recipe.newRecipe.requiredItem[0].stack = 24;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1505, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1508, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1506, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1508, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1507, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1508, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1543, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1508, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1544, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1508, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1545, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1508, false);
			Recipe.newRecipe.requiredItem[0].stack = 8;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1316, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1328, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1317, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 24;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1328, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1318, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1328, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1552, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1006, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(183, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 247;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1546, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1552, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1547, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1552, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1548, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1552, false);
			Recipe.newRecipe.requiredItem[0].stack = 12;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1549, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1552, false);
			Recipe.newRecipe.requiredItem[0].stack = 24;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1550, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1552, false);
			Recipe.newRecipe.requiredItem[0].stack = 18;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(533, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(98, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(324, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(319, false);
			Recipe.newRecipe.requiredItem[2].stack = 5;
			Recipe.newRecipe.requiredItem[3].SetDefaults(548, false);
			Recipe.newRecipe.requiredItem[3].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(561, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1225, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredItem[2].SetDefaults(548, false);
			Recipe.newRecipe.requiredItem[2].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(506, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(324, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(547, false);
			Recipe.newRecipe.requiredItem[2].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(494, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(508, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[1].stack = 25;
			Recipe.newRecipe.requiredItem[2].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[2].stack = 12;
			Recipe.newRecipe.requiredItem[3].SetDefaults(549, false);
			Recipe.newRecipe.requiredItem[3].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(425, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(507, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(501, false);
			Recipe.newRecipe.requiredItem[1].stack = 80;
			Recipe.newRecipe.requiredItem[2].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[2].stack = 12;
			Recipe.newRecipe.requiredItem[3].SetDefaults(549, false);
			Recipe.newRecipe.requiredItem[3].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(497, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(275, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredItem[1].SetDefaults(319, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredItem[2].SetDefaults(261, false);
			Recipe.newRecipe.requiredItem[2].stack = 15;
			Recipe.newRecipe.requiredItem[3].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[3].stack = 5;
			Recipe.newRecipe.requiredItem[4].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[4].stack = 5;
			Recipe.newRecipe.requiredItem[5].SetDefaults(547, false);
			Recipe.newRecipe.requiredItem[5].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(495, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredItem[1].SetDefaults(526, false);
			Recipe.newRecipe.requiredItem[1].stack = 4;
			Recipe.newRecipe.requiredItem[2].SetDefaults(501, false);
			Recipe.newRecipe.requiredItem[2].stack = 60;
			Recipe.newRecipe.requiredItem[3].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[3].stack = 10;
			Recipe.newRecipe.requiredItem[4].SetDefaults(549, false);
			Recipe.newRecipe.requiredItem[4].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(493, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(320, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[1].stack = 20;
			Recipe.newRecipe.requiredItem[2].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[2].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(492, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(320, false);
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[1].stack = 20;
			Recipe.newRecipe.requiredItem[2].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[2].stack = 25;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(761, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(501, false);
			Recipe.newRecipe.requiredItem[1].stack = 100;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(785, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1516, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(749, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1611, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(786, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1517, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(821, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1518, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(822, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1519, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1165, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1520, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1515, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1521, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(823, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(575, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1508, false);
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1085, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1073, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1086, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1074, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1087, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1075, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1088, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1076, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1089, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1077, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1090, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1078, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1091, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1079, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1092, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1080, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1093, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1081, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1094, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1082, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1095, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1083, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1096, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1084, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1007, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1115, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1008, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1114, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1009, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1110, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1010, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1112, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1011, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1108, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1012, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1107, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1013, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1116, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1014, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1109, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1015, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1111, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1016, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1118, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1017, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1117, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1018, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1113, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1050, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1119, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1031, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1007, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1008, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1009, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1033, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1009, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1010, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1011, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1035, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1013, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1014, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1015, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1063, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1031, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1064, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1033, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1065, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1035, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1032, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1031, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1034, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1033, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1036, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1035, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1068, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1008, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1009, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1010, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1069, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1012, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1013, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1014, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1070, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1016, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1017, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1018, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1066, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1068, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1069, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(1070, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1067, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1066, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1019, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1007, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1020, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1008, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1021, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1009, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1022, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1010, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1023, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1011, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1024, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1012, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1025, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1013, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1026, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1014, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1027, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1015, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1028, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1016, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1029, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1017, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1030, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1018, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1050, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1038, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1007, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1039, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1008, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1040, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1009, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1041, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1010, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1042, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1011, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1043, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1012, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1044, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1013, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1045, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1014, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1046, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1015, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1047, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1016, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1048, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1017, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1049, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1018, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1051, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1007, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1052, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1008, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1053, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1009, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1054, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1010, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1055, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1011, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1056, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1012, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1057, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1013, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1058, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1014, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1059, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1015, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1060, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1016, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1061, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1017, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1062, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1018, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1037, false);
			Recipe.newRecipe.requiredTile[0] = 228;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(394, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(187, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(268, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(395, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(17, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(18, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(393, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(395, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(709, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(18, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(393, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(396, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(158, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(193, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(397, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(156, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(193, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1613, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(397, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1612, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1724, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(53, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(215, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(399, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(53, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(159, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1163, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(987, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(159, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(983, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(857, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(159, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1250, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(399, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(158, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1251, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1163, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(158, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1252, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(983, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(158, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1164, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(399, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1163, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(983, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(405, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(54, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(128, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(405, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1579, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(128, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(898, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(405, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(212, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(285, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(907, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(863, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(193, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(908, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(907, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(906, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(555, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(223, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(189, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(897, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(536, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(211, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(936, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(897, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(935, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1343, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1322, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(936, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(982, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(111, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(49, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1595, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(982, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(216, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(860, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(49, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(535, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(861, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(485, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(497, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(862, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(532, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(554, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1247, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1132, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(532, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1578, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1132, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1290, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(976, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(953, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(975, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(984, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(976, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(977, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(963, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(901, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(886, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(892, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(902, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(887, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(885, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(903, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(889, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(893, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(904, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(890, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(891, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1612, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(901, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(902, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(903, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults(904, false);
			Recipe.newRecipe.requiredItem[4].SetDefaults(888, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(935, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(489, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(490, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(491, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1301, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(935, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1248, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(193, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(173, false);
			Recipe.newRecipe.requiredItem[0].stack = 20;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(518, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(531, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(502, false);
			Recipe.newRecipe.requiredItem[1].stack = 30;
			Recipe.newRecipe.requiredItem[2].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[2].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 101;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(519, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(531, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(522, false);
			Recipe.newRecipe.requiredItem[1].stack = 30;
			Recipe.newRecipe.requiredItem[2].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[2].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 101;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1336, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(531, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(1332, false);
			Recipe.newRecipe.requiredItem[1].stack = 30;
			Recipe.newRecipe.requiredItem[2].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[2].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 101;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Goggles");
			Recipe.newRecipe.requiredItem[0].SetDefaults(38, false);
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.requiredTile[1] = 15;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(266, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(324, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(323, false);
			Recipe.newRecipe.requiredItem[1].stack = 10;
			Recipe.newRecipe.requiredItem[2].SetDefaults(180, false);
			Recipe.newRecipe.requiredItem[2].stack = 5;
			Recipe.newRecipe.requiredTile[0] = 17;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Sunglasses");
			Recipe.newRecipe.requiredItem[0].SetDefaults("Black Lens");
			Recipe.newRecipe.requiredItem[0].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 18;
			Recipe.newRecipe.requiredTile[1] = 15;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults("Mana Crystal");
			Recipe.newRecipe.requiredItem[0].SetDefaults(75, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(511, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(530, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(512, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(26, false);
			Recipe.newRecipe.requiredItem[0].stack = 4;
			Recipe.newRecipe.requiredItem[1].SetDefaults(530, false);
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(580, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(167, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(581, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Iron Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(582, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults("Iron Bar");
			Recipe.newRecipe.requiredItem[0].stack = 10;
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.newRecipe.requiredItem[1].stack = 2;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(583, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(17, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(583, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(709, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(584, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(16, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(584, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(708, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(585, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(15, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(585, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(707, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults("Wire");
			Recipe.newRecipe.requiredItem[1].stack = 1;
			Recipe.newRecipe.requiredTile[0] = 16;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(540, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(3, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(565, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(562, false);
			Recipe.newRecipe.requiredItem[1].SetDefaults(563, false);
			Recipe.newRecipe.requiredItem[2].SetDefaults(564, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults(566, false);
			Recipe.newRecipe.requiredItem[4].SetDefaults(567, false);
			Recipe.newRecipe.requiredItem[5].SetDefaults(568, false);
			Recipe.newRecipe.requiredItem[6].SetDefaults(569, false);
			Recipe.newRecipe.requiredItem[7].SetDefaults(570, false);
			Recipe.newRecipe.requiredItem[8].SetDefaults(571, false);
			Recipe.newRecipe.requiredItem[9].SetDefaults(572, false);
			Recipe.newRecipe.requiredItem[10].SetDefaults(573, false);
			Recipe.newRecipe.requiredItem[11].SetDefaults(574, false);
			Recipe.newRecipe.requiredTile[0] = 114;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(43, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(38, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 26;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(70, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(67, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredItem[1].SetDefaults(68, false);
			Recipe.newRecipe.requiredItem[1].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 26;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1331, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1330, false);
			Recipe.newRecipe.requiredItem[0].stack = 15;
			Recipe.newRecipe.requiredTile[0] = 26;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(1133, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1125, false);
			Recipe.newRecipe.requiredItem[0].stack = 5;
			Recipe.newRecipe.requiredItem[1].SetDefaults(1127, false);
			Recipe.newRecipe.requiredItem[1].stack = 3;
			Recipe.newRecipe.requiredItem[2].SetDefaults(209, false);
			Recipe.newRecipe.requiredItem[3].SetDefaults(1124, false);
			Recipe.newRecipe.requiredItem[3].stack = 5;
			Recipe.newRecipe.requiredItem[4].SetDefaults(173, false);
			Recipe.newRecipe.requiredItem[4].stack = 2;
			Recipe.newRecipe.requiredItem[5].SetDefaults(1134, false);
			Recipe.newRecipe.requiredTile[0] = 26;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(560, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(23, false);
			Recipe.newRecipe.requiredItem[0].stack = 99;
			Recipe.newRecipe.requiredItem[1].SetDefaults(264, false);
			Recipe.newRecipe.requiredTile[0] = 26;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(560, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(23, false);
			Recipe.newRecipe.requiredItem[0].stack = 99;
			Recipe.newRecipe.requiredItem[1].SetDefaults(715, false);
			Recipe.newRecipe.requiredTile[0] = 26;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(544, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(38, false);
			Recipe.newRecipe.requiredItem[0].stack = 3;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredItem[2].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[2].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(556, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(68, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredItem[2].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[2].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(556, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(1330, false);
			Recipe.newRecipe.requiredItem[0].stack = 6;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredItem[2].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[2].stack = 6;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(557, false);
			Recipe.newRecipe.requiredItem[0].SetDefaults(154, false);
			Recipe.newRecipe.requiredItem[0].stack = 30;
			Recipe.newRecipe.requiredItem[1].SetDefaults(22, false);
			Recipe.newRecipe.requiredItem[1].stack = 5;
			Recipe.newRecipe.requiredItem[2].SetDefaults(520, false);
			Recipe.newRecipe.requiredItem[2].stack = 3;
			Recipe.newRecipe.requiredItem[3].SetDefaults(521, false);
			Recipe.newRecipe.requiredItem[3].stack = 3;
			Recipe.newRecipe.requiredTile[0] = 134;
			Recipe.newRecipe.anyIronBar = true;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(71, false);
			Recipe.newRecipe.createItem.stack = 100;
			Recipe.newRecipe.requiredItem[0].SetDefaults(72, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(72, false);
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults(71, false);
			Recipe.newRecipe.requiredItem[0].stack = 100;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(72, false);
			Recipe.newRecipe.createItem.stack = 100;
			Recipe.newRecipe.requiredItem[0].SetDefaults(73, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(73, false);
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults(72, false);
			Recipe.newRecipe.requiredItem[0].stack = 100;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(73, false);
			Recipe.newRecipe.createItem.stack = 100;
			Recipe.newRecipe.requiredItem[0].SetDefaults(74, false);
			Recipe.newRecipe.requiredItem[0].stack = 1;
			Recipe.addRecipe();
			Recipe.newRecipe.createItem.SetDefaults(74, false);
			Recipe.newRecipe.createItem.stack = 1;
			Recipe.newRecipe.requiredItem[0].SetDefaults(73, false);
			Recipe.newRecipe.requiredItem[0].stack = 100;
			Recipe.addRecipe();
			Recipe.wallReturn();
			for (int i = 0; i < Recipe.numRecipes; i++)
			{
				int num = 0;
				while (Main.recipe[i].requiredItem[num].type > 0)
				{
					Main.recipe[i].requiredItem[num].checkMat();
					num++;
				}
				Main.recipe[i].createItem.checkMat();
			}
		}
		private static void wallReturn()
		{
			int num = Recipe.numRecipes;
			for (int i = 0; i < num; i++)
			{
				if (Main.recipe[i].createItem.createWall > 0 && Main.recipe[i].requiredItem[1].type == 0)
				{
					Recipe.newRecipe.createItem.SetDefaults(Main.recipe[i].requiredItem[0].type, false);
					Recipe.newRecipe.createItem.stack = Main.recipe[i].requiredItem[0].stack;
					Recipe.newRecipe.requiredItem[0].SetDefaults(Main.recipe[i].createItem.type, false);
					Recipe.newRecipe.requiredItem[0].stack = Main.recipe[i].createItem.stack;
					for (int j = 0; j < Recipe.newRecipe.requiredTile.Length; j++)
					{
						Recipe.newRecipe.requiredTile[j] = Main.recipe[i].requiredTile[j];
					}
					Recipe.addRecipe();
					Recipe recipe = Main.recipe[Recipe.numRecipes - 1];
					for (int k = Recipe.numRecipes - 2; k > i; k--)
					{
						Main.recipe[k + 1] = Main.recipe[k];
					}
					Main.recipe[i + 1] = recipe;
				}
			}
		}
		private static void addRecipe()
		{
			Main.recipe[Recipe.numRecipes] = Recipe.newRecipe;
			Recipe.newRecipe = new Recipe();
			Recipe.numRecipes++;
		}
	}
}
